unit maincalc;


{******************************************************************************}
{                                                                              }
{                           IMPORTANT NOTICE                                   }
{                                                                              }
{              (c) Copyright 2001 by Alirio A. Gavidia B.                      }
{                                                                              }
{                         ALL RIGHTS RESERVED                                  }
{                                                                              }
{                                                                              }
{       Portions may be Copyright (c) 1995 Borland International.              }
{       All restriction apply.                                                 }
{******************************************************************************}
{******************************************************************************}
{  Version 1.0.0  02-Jun-2000                                                  }
{  Version 2.0.0  09-Ago-2000                                                  }
{                                                                              }
{  by Alirio A. Gavidia B.     email:   alirio@gavidia.org                     }
{                                                                              }
{******************************************************************************}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, StdActns, ActnList, Menus, HalCustomExpr,
  HalSimpleExpr;

type
  TfCalc = class(TForm)
    Label1: TLabel;
    EdExp: TEdit;
    lblResult: TLabel;
    Label2: TLabel;
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    mmEdit: TMenuItem;
    mmModo: TMenuItem;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    ActSep: TAction;
    ActNoSep: TAction;
    ActCopyRes: TAction;
    Copiarresultado1: TMenuItem;
    Sinseparadores1: TMenuItem;
    Conseparadores1: TMenuItem;
    HalSimpleExpr1: THalSimpleExpr;
    procedure FormCreate(Sender: TObject);
    procedure EdExpKeyPress(Sender: TObject; var Key: Char);
    procedure ActSepExecute(Sender: TObject);
    procedure ActNoSepExecute(Sender: TObject);
    procedure ActCopyResExecute(Sender: TObject);
  private
    { Private declarations }
    mode : (formated, noformated);
  public
    { Public declarations }
  end;

var
  fCalc: TfCalc;

implementation

uses Clipbrd;

{$R *.DFM}



procedure TfCalc.FormCreate(Sender: TObject);
begin
  mode := formated;
  ActSep.Checked := true;
end;

procedure TfCalc.EdExpKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then
   begin
     if (mode = formated) then
       Panel1.Caption :=  formatFloat('#,##0.00',HalSimpleExpr1.EvalFloat(EdExp.Text))
     else
       Panel1.Caption :=  HalSimpleExpr1.EvalString(EdExp.Text);
     Key := #0
   end
 else if Key in ['0'..'9','.','+','-','*','/','%',#8] then
   begin
     HalSimpleExpr1.Expression := EdExp.Text + Key;
     try
      Panel1.Caption := '';
      HalSimpleExpr1.Prepare;
     except
      Panel1.Caption := 'Error';
      Key := #0;
     end
   end
 else
   Key := #0
end;

procedure TfCalc.ActSepExecute(Sender: TObject);
begin
  ActSep.Checked := true;
  ActNoSep.Checked := false;
  mode := formated;
end;

procedure TfCalc.ActNoSepExecute(Sender: TObject);
begin
  ActSep.Checked := false;
  ActNoSep.Checked := true;
  mode := noformated
end;

procedure TfCalc.ActCopyResExecute(Sender: TObject);
begin
  Clipboard.SetTextBuf(Pchar(Panel1.Caption))
end;

end.
